#include <gnome.h>
#include "fractroam.h"

GtkWidget *darea;

guchar* buf;
guchar* buf_scaled;

double scale[6];

gint MYWIDTH, MYHEIGHT;

//int julia_toggle=0;

void print(void);

void quit_cb(GtkWidget *widget) { 
  gtk_main_quit();
}

gint click_cb(GtkWidget *widget, GdkEvent *event, gpointer data) {
  //process mouseclick (center screen) and set it on, let fractroam handle logic
  //right button == toggle autopilot, left button == center
  if (event->button.button == 3) {  //right == toggle autopilot
    fract_pilot_toggle();
  } else if (event->button.button == 1) { //left == center
    fract_center(event->button.x,MYHEIGHT-event->button.y);
  } else if (event->button.button == 2) { //toggle style (organic vs. normal)
    fract_style_toggle();
  }
  tick_event(NULL);
}

gint key_cb(GtkWidget *widget, GdkEvent *event, gpointer data) {
  char message[360];
  //process keystroke and send it on, let the fractroam body handle any logic
	switch(event->key.keyval) {
		case GDK_space:
		case GDK_a: fract_pilot_toggle(); tick_event(NULL); break;
		case GDK_d:
    	//print out bounds
    	sprintf(message,"xmin: %f, xmax: %f, ymin: %f, ymax:%f\nx: %f, y: %f, width: %f (scale??)\n----\n",fract_bounds_get().xmin,fract_bounds_get().xmax,fract_bounds_get().ymin,fract_bounds_get().ymax,(fract_bounds_get().xmin+fract_bounds_get().xmax)/2, (fract_bounds_get().ymin+fract_bounds_get().ymax)/2,fract_bounds_get().xmax-fract_bounds_get().xmin);
			gnome_ok_dialog(message);
		break;
		case GDK_q: quit_cb(NULL); break;
		case GDK_h: fract_move(0,-1,0); tick_event(NULL); break;
    case GDK_j: fract_move(-1,0,0); tick_event(NULL); break;
    case GDK_k: fract_move(1,0,0); tick_event(NULL); break;
		case GDK_l: fract_move(0,1,0); tick_event(NULL); break;
    case GDK_z: fract_move(0,0,-1); tick_event(NULL); break;
    case GDK_x: fract_move(0,0,1); tick_event(NULL); break;
		case GDK_s: fract_style_toggle(); tick_event(NULL); break;
		case GDK_t: fract_targets_toggle(); tick_event(NULL); break;
		case GDK_c: fract_color_cycle(); tick_event(NULL); break;
		//case GDK_n: julia_toggle=!julia_toggle; tick_event(NULL); break;
		case GDK_p:
    	sprintf(message,"/usr/X11R6/bin/xfractint corners=%f/%f/%f/%f",fract_bounds_get().xmin,fract_bounds_get().xmax,fract_bounds_get().ymin,fract_bounds_get().ymax);
    	system(message);
		break;
		default: break;
  }
}

void resize_cb(GtkWidget *widget, GdkEvent *event, gpointer data) {
  if (widget != darea) {
    if (MYWIDTH != event->configure.width || MYHEIGHT != event->configure.height){
  gtk_drawing_area_size(GTK_DRAWING_AREA(darea),MYWIDTH,MYHEIGHT);
      //gtk_widget_set_usize(darea,-1,-1);
      //gtk_widget_set_usize(darea,MYWIDTH,MYHEIGHT);
    }
  } else { //widget == darea
      MYWIDTH = event->configure.width;
      MYHEIGHT = event->configure.height;
      free(buf_scaled);
      buf_scaled = (guchar*) malloc(MYWIDTH*MYHEIGHT*FRACT_STEP*sizeof(guchar));
  printf("MYWIDTH: %d; MYHEIGHT:%d\n",MYWIDTH,MYHEIGHT);
  }
}

void expose_cb(GtkWidget *widget) {
  print();
}

gboolean tick_event(gpointer data) {
  fract_update();
  fract_plot();
  print();
  return TRUE;
}

void init() {
  buf= (guchar*) malloc(fract_size_get().width*fract_size_get().height*FRACT_STEP*sizeof(guchar));
}


//blit the fractal to the screen?
void print() {
  int width,height,i,x,y;
  short* fractal;
  //if (julia_toggle) {
//printf("JULIA: %d\n",julia_toggle);
    //fract_plot_julia_by_center();
    //fractal=fract_julia_get();
  //} else {
    fractal=fract_get();
  //}
  //GdkImlibImage *im;
  width=(fract_size_get()).width;
  height=(fract_size_get()).height;
  i=(width*height*FRACT_STEP)-1;
  for (;i>=0;i--) buf[i]=fractal[i];
  //do scaled version?
  for (y=0;y<MYHEIGHT;y++) {
    for (x=0;x<MYWIDTH;x++) {
      if (y < height && x < width) {
        buf_scaled[(x+y*MYWIDTH)*FRACT_STEP] = fractal[(x+y*width)*FRACT_STEP];
        //buf_scaled[(x+y*MYWIDTH)*FRACT_STEP+1] = fractal[(x+y*width)*FRACT_STEP+1];
        buf_scaled[(x+y*MYWIDTH)*FRACT_STEP+1] = fractal[(x+y*width)*FRACT_STEP];
        if (fractal[(x+y*width)*FRACT_STEP+2] == 0)
          buf_scaled[(x+y*MYWIDTH)*FRACT_STEP+2] = fractal[(x+y*width)*FRACT_STEP];
        else
          buf_scaled[(x+y*MYWIDTH)*FRACT_STEP+2] = fractal[(x+y*width)*FRACT_STEP+2];
      } else {
//printf("x: %d, y: %d\n; MYWIDTH: %d, MYHEIGHT: %d\n",x,y,MYWIDTH,MYHEIGHT);
        buf_scaled[(x+y*MYWIDTH)*FRACT_STEP-1] = x;
      }
    }
  }
  //then draw_rgb_image the scaled version!
  //gdk_draw_rgb_image(darea->window,darea->style->fg_gc[GTK_STATE_NORMAL],0,0,width,height,GDK_RGB_DITHER_NONE,buf,width*FRACT_STEP);
  gdk_draw_rgb_image(darea->window,darea->style->fg_gc[GTK_STATE_NORMAL],0,0,MYWIDTH,MYHEIGHT,GDK_RGB_DITHER_NONE,buf_scaled,MYWIDTH*FRACT_STEP);
}


int main(int argc, char* argv[]) {
  GtkWidget *app;

  if (argc != 1) {
    printf("\nThis program takes no commandline arguments at the moment.\n\n  right click, or hit spacebar or a to toggle autopilot.\n  middle click or hit s to toggle style\n\n  While autopilot is off:\n    left click: center on point\n    hjkl: left, down, up, right\n    d: display coordinates\n    q: quit\n\n");
    exit(1);
  }

  gnome_init("GnoFractRoam",VERSION,argc,argv); // calls gdk_rgb_init()

  gtk_widget_push_visual(gdk_rgb_get_visual());
  gtk_widget_push_colormap(gdk_rgb_get_cmap());
  app=gnome_app_new("GnoFractRoam","GnoFractRoam");
  gtk_widget_pop_visual();
  gtk_widget_pop_colormap();

  gtk_widget_add_events(GTK_WIDGET(app),GDK_KEY_PRESS_MASK|GDK_STRUCTURE_MASK);
  gtk_signal_connect(GTK_OBJECT(app),"delete_event",GTK_SIGNAL_FUNC(quit_cb),NULL);
  gtk_signal_connect(GTK_OBJECT(app),"key_press_event",GTK_SIGNAL_FUNC(key_cb),NULL);
  gtk_signal_connect(GTK_OBJECT(app),"configure_event",GTK_SIGNAL_FUNC(resize_cb),NULL);
  gtk_window_set_default_size(GTK_WINDOW(app),DEFAULT_FRACT_WIDTH,DEFAULT_FRACT_HEIGHT);

  darea=gtk_drawing_area_new();
  gtk_drawing_area_size(GTK_DRAWING_AREA(darea),DEFAULT_FRACT_WIDTH,DEFAULT_FRACT_HEIGHT);
  gtk_widget_add_events(GTK_WIDGET(darea),GDK_BUTTON_PRESS_MASK|GDK_KEY_PRESS_MASK);
  gtk_signal_connect(GTK_OBJECT(darea),"button_press_event",GTK_SIGNAL_FUNC(click_cb),NULL);
  gtk_signal_connect(GTK_OBJECT(darea),"delete_event",GTK_SIGNAL_FUNC(quit_cb),NULL);
  gtk_signal_connect(GTK_OBJECT(darea),"expose_event",GTK_SIGNAL_FUNC(expose_cb),NULL);
  gtk_signal_connect(GTK_OBJECT(darea),"configure_event",GTK_SIGNAL_FUNC(resize_cb),NULL);
  gnome_app_set_contents(GNOME_APP(app),darea);
  
  //initialize fractal stuff
  fract_init();
  fract_plot();
  init();
  gtk_timeout_add(125,tick_event,NULL);
  gtk_widget_show_all(app);
  gtk_main();
  return 0;
}
